<template>
    <q-form @submit="!selectedRow.id ? addTodo() : updateTodo()" class="q-ma-md">
      <q-input v-model="form.title" label="Input Field" />
      <q-btn :loading="btnLoadingState" type="submit" :label="!selectedRow.id ? 'Submit' : 'Update'" color="primary" />
      <q-btn :loading="deleteBtnLoadingState" v-if="selectedRow.id" @click="deleteTodo()" class="q-ml-md" label="Delete" color="negative" />
    </q-form>
  <q-page class="q-ma-xl">
    <q-table title="Todos" :rows="rows" :columns="columns" row-key="name" @row-click="onRowClick" />
  </q-page>
</template>

<script>
  import { ref } from 'vue'
  import axios from 'axios'

  export default {
    setup() {
      let rows = ref([])
      
      let columns = ref([
        {
          name: 'title',
          label: 'Title',
          align: 'left',
          field: 'title'
        },
        {
          name: 'completed',
          label: 'Completed',
          align: 'left',
          field: 'completed'
        },
      ])

      let form = ref({
        userId: 1,
        title: null,
        completed: false
      })

      let btnLoadingState = ref(false)

      let selectedRow = ref({})

      let deleteBtnLoadingState = ref(false)

      const deleteTodo = async () => {
        deleteBtnLoadingState.value = true

        const response = await axios.delete(`https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`)
        console.log(response)
        
        if (response.status === 200) {
        rows.value = rows.value.filter(row => row.id !== selectedRow.value.id)
        form.value.title = null
        selectedRow.value = {}
        }

        deleteBtnLoadingState.value = false
      }

      const onRowClick = (event, row) => {
        console.log(row)
        selectedRow.value = row
        form.value.title = row.title
      }

      const updateTodo = async () => {
        btnLoadingState.value = true

        // The code below handles the update of user created todo
        // JSONPlaceholder's resource doesn't update when user created a resource
        // so any IDs greater than 200 will return a status 500 when the API is called
        if (selectedRow.value.id > 200) {
          const index = rows.value.findIndex(row => row.id === selectedRow.value.id)
          rows.value[index].title = form.value.title
          form.value.title = null
          selectedRow.value = {}
          btnLoadingState.value = false
          return
        }

        const response = await axios.put(
          `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`,
          { title: form.value.title }
        )

        if (response.status === 200) {
          const index = rows.value.findIndex(row => row.id === selectedRow.value.id)
          rows.value[index].title = response.data.title
          form.value.title = null
          selectedRow.value = {}
        }

        btnLoadingState.value = false
      }

      const addTodo = async () => {
        btnLoadingState.value = true

        const response = await axios.post('https://jsonplaceholder.typicode.com/todos', form.value)
        console.log(response)
        if (response.status === 201) {
          rows.value.unshift(response.data)
          form.value.title = null
        }

        btnLoadingState.value = false
      }

      const getTodos = async () => {
        const response = await axios.get('https://jsonplaceholder.typicode.com/todos')
              rows.value = response.data
      }

      getTodos()

      return { rows, columns, form, btnLoadingState, selectedRow, addTodo, onRowClick, updateTodo, deleteBtnLoadingState, deleteTodo }
    }
  }
</script>
